/****************************************************************************
 * (c) 2018 softwareentwicklung-als-prozess.de
 * Funktionalitaet:
 * Strom messen
 ***************************************************************************/
// Includes -----------------------------------------------------------------
#include <arduino.h>
#include "imess.h"

// Defines ------------------------------------------------------------------
#define KEIN_STROM 0.0
#define MINDEST_STROM 0.07
#define NENN_STROM 0.12

// Variablen ----------------------------------------------------------------
int mVperAmp  = 185; // use 100 for 20A Module and 66 for 30A Module
int ACSoffset = 2500; 

// interne Prototypen -------------------------------------------------------
static float SystemCurrent(void);

// Funktionen ---------------------------------------------------------------
StromStatus SystemStromUeberwachung(void)
{
  float current = 0.0;
  StromStatus retval = kein;

  current = SystemCurrent();
  current = abs(current);        // die fliessrichtung ist egal
  if (current == KEIN_STROM)
  {
    retval = kein;
  }
  else
  {
    if (current < MINDEST_STROM)
    {
      retval = mindest;
    }
    else
    {
      retval = minder;
    }
    if(current > NENN_STROM)
    {
      retval = nenn;
    }
  }
  return(retval);
}

static float SystemCurrent(void)
{
  float current = 0.0;
  int at_read   = 0;
  
  at_read = analogRead(A1);
  current = (((at_read / 1024.0) * 5000) - ACSoffset) / mVperAmp;
  return(current);
}
